<?php

namespace App\Entity;

use App\Repository\PrehistoricRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: PrehistoricRepository::class)]
#[ORM\Table(name: 'preistoria')]
class Prehistoric implements \JsonSerializable
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255, name: 'denominazione')]
    private ?string $denomination = null;

    #[ORM\Column(length: 255, nullable: true, name: 'loc_generica')]
    private ?string $genericPlace = null;

    #[ORM\Column(length: 120, nullable: true, name: 'periodo')]
    private ?string $period = null;

    #[ORM\Column(type: Types::TEXT, nullable: true, name: 'descrizione')]
    private ?string $description = null;

    #[ORM\Column(length: 255, nullable: true, name: 'conservazione')]
    private ?string $conservation = null;

    #[ORM\Column(length: 255, nullable: true, name: 'autore_scheda')]
    private ?string $author = null;

    #[ORM\Column(name: 'comune', length: 10, nullable: false)]
    private ?string $municipality = null;

    #[ORM\Column(name: 'etichetta', length: 150, nullable: false)]
    private ?string $label = null;

    private ?float $lat;

    private ?float $lng;

    /**
     * @var Image[] $images
     */
    private ?array $images = null;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function setId(string $id): static
    {
        $this->id = $id;

        return $this;
    }

    public function getDenomination(): ?string
    {
        return $this->denomination;
    }

    public function setDenomination(string $denomination): static
    {
        $this->denomination = $denomination;

        return $this;
    }

    public function getGenericPlace(): ?string
    {
        return $this->genericPlace;
    }

    public function setGenericPlace(?string $genericPlace): static
    {
        $this->genericPlace = $genericPlace;

        return $this;
    }

    public function getPeriod(): ?string
    {
        return $this->period;
    }

    public function setPeriod(?string $period): static
    {
        $this->period = $period;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): static
    {
        $this->description = $description;

        return $this;
    }

    public function getConservation(): ?string
    {
        return $this->conservation;
    }

    public function setConservation(?string $conservation): static
    {
        $this->conservation = $conservation;

        return $this;
    }

    public function getAuthor(): ?string
    {
        return $this->author;
    }

    public function setAuthor(?string $author): static
    {
        $this->author = $author;

        return $this;
    }

    public function getLat(): ?float
    {
        return $this->lat;
    }

    public function setLat(float $lat): static
    {
        $this->lat = $lat;

        return $this;
    }

    public function getLng(): ?float
    {
        return $this->lng;
    }

    public function setLng(float $lng): static
    {
        $this->lng = $lng;

        return $this;
    }

    /**
     * @return Image[]
     */
    public function getImages(): array
    {
        return $this->images;
    }

    /**
     * @param Image[] $images
     */
    public function setImages(array $images): static
    {
        $this->images = $images;

        return $this;
    }
 
    public function getLabel(): ?string
    {
        return $this->label;
    }

    public function setLabel(?string $label): static
    {
        $this->label = $label;

        return $this;
    }

    public function getMunicipality(): ?string
    {
        return $this->municipality;
    }

    public function setMunicipality(?string $municipality): static
    {
        $this->municipality = $municipality;

        return $this;
    }

    public function jsonSerialize(): array
    {
        return [
            'id' => $this->id,
            'denomination' => $this->denomination,
            'genericPlace' => $this->genericPlace,
            'period' => $this->period,
            'conservation' => $this->conservation,
            'author' => $this->author,
            'description' => $this->description,
            'label' => $this->label,
            'municipality' => $this->municipality,
            'coordinates' => [$this->lat, $this->lng],
            'images' => $this->images,
        ];
    }
}
