<?php

namespace App\Repository;

use App\Entity\Underwater;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<Underwater>
 */
class UnderwaterRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Underwater::class);
    }

    public function coordinates(int $id)
    {
        $conn = $this->getEntityManager()->getConnection();

        $sql = '
            SELECT
                ST_X(ST_AsText(coordinate)) as lng,
                ST_Y(ST_AsText(coordinate)) as lat
            FROM
                giacimento
            WHERE id = :id
        ';

        return $conn
            ->executeQuery($sql, ['id' => $id])
            ->fetchAssociative();
    }

    //    /**
    //     * @return Underwater[] Returns an array of Underwater objects
    //     */
    //    public function findByExampleField($value): array
    //    {
    //        return $this->createQueryBuilder('u')
    //            ->andWhere('u.exampleField = :val')
    //            ->setParameter('val', $value)
    //            ->orderBy('u.id', 'ASC')
    //            ->setMaxResults(10)
    //            ->getQuery()
    //            ->getResult()
    //        ;
    //    }

    //    public function findOneBySomeField($value): ?Underwater
    //    {
    //        return $this->createQueryBuilder('u')
    //            ->andWhere('u.exampleField = :val')
    //            ->setParameter('val', $value)
    //            ->getQuery()
    //            ->getOneOrNullResult()
    //        ;
    //    }
}
